using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Windows;
using System.IO;
using System.Drawing;
using AGV_WPF_Global;
using System.Threading;
using System.Diagnostics;

namespace AGV_WPF
{
    /// <summary>
    /// App.xaml Ľ߼
    /// </summary>
    public partial class App : Application
    {
        public App()
        {
            //if (!CheckApp())
            //{
            //    MessageBox.Show("нǰ");
            //    this.Shutdown();
            //}
            Application.Current.DispatcherUnhandledException += new System.Windows.Threading.DispatcherUnhandledExceptionEventHandler(Current_DispatcherUnhandledException);
            AppDomain.CurrentDomain.UnhandledException += new UnhandledExceptionEventHandler(CurrentDomain_UnhandledException);
            DirectoryInfo info = new DirectoryInfo("Exception");
            if (!info.Exists)
            {
                Directory.CreateDirectory("Exception");
            }
            DirectoryInfo info1 = new DirectoryInfo("Link");
            if (!info1.Exists)
            {
                Directory.CreateDirectory("Link");
            }
            GlobalPara.LoadData();
        }
        
        void CurrentDomain_UnhandledException(object sender, UnhandledExceptionEventArgs e)
        {
            try
            {
                DateTime time = DateTime.Now;
                //MessageBox.Show("߳쳣:"+e.ExceptionObject);
                FileStream stream = File.Open(@"Exception\쳣.txt", FileMode.Append, FileAccess.Write);
                StreamWriter writer = new StreamWriter(stream);
                Exception exc = e.ExceptionObject as Exception;
                if (exc != null)
                {
                    string msg = string.Format("[{0}]߳:\r\nMessage:{1}\r\nStackTrace:\r\n{2}", time.ToString("yyyy-MM-dd HH:mm:ss"), exc.Message, exc.StackTrace);
                    writer.WriteLine(msg);
                    writer.Close();
                    stream.Close();
                }

                if (GlobalPara.IsExceptionSavePic)
                {
                    try
                    {
                        string fileName = string.Format("{0}{1:d2}{2:d2}{3:d2}{4:d2}{5:d2}", time.Year, time.Month, time.Day, time.Hour, time.Minute, time.Second);
                        Rectangle rect = System.Windows.Forms.SystemInformation.VirtualScreen;
                        Bitmap bmp = new Bitmap(rect.Width, rect.Height, System.Drawing.Imaging.PixelFormat.Format32bppArgb);
                        Graphics g = Graphics.FromImage(bmp);
                        g.CopyFromScreen(rect.X, rect.Y, 0, 0, rect.Size, CopyPixelOperation.SourceCopy);
                        bmp.Save(@"Exception\" + fileName + ".png");
                    }
                    catch (System.Exception ex)
                    {
                        
                        throw ex;
                    }
                }
            }
            catch (Exception ex)
            {
                //ŵ¼ĴҪʱĲ
                //CmdStartCTIProc(System.Windows.Forms.Application.ExecutablePath, "cmd params");
                throw ex;
            }
        }

        void Current_DispatcherUnhandledException(object sender, System.Windows.Threading.DispatcherUnhandledExceptionEventArgs e)
        {
            DateTime time = DateTime.Now;
            try
            {
                FileStream stream = File.Open(@"Exception\쳣.txt", FileMode.Append, FileAccess.Write);
                StreamWriter writer = new StreamWriter(stream);
                Exception exc = e.Exception;
                if (exc != null)
                {
                    string msg = string.Format("[{0}]UI߳:\r\nMessage:{1}\r\nStackTrace:\r\n{2}", time.ToString("yyyy-MM-dd HH:mm:ss"), exc.Message, exc.StackTrace);
                    writer.WriteLine(msg);
                    writer.Close();
                    stream.Close();
                }

                e.Handled = true;//ʹһдʱ쳣ˣΪUnhandledException׳ˡ
                if (GlobalPara.IsExceptionSavePic)
                {
                    try
                    {
                        string fileName = string.Format("{0}{1:d2}{2:d2}{3:d2}{4:d2}{5:d2}", time.Year, time.Month, time.Day, time.Hour, time.Minute, time.Second);
                        Rectangle rect = System.Windows.Forms.SystemInformation.VirtualScreen;
                        Bitmap bmp = new Bitmap(rect.Width, rect.Height, System.Drawing.Imaging.PixelFormat.Format32bppArgb);
                        Graphics g = Graphics.FromImage(bmp);
                        g.CopyFromScreen(rect.X, rect.Y, 0, 0, rect.Size, CopyPixelOperation.SourceCopy);
                        bmp.Save(@"Exception\" + fileName + ".png");

                    }
                    catch (System.Exception ex)
                    {
                        MessageBox.Show(ex.Message);
                    }
                }
            }
            catch(Exception ex)
            {
                //ŵ¼ĴҪʱĲ
                //CmdStartCTIProc(System.Windows.Forms.Application.ExecutablePath, "cmd params");
                MessageBox.Show(ex.Message);

            }
        }
        
        static Mutex appMutex = new Mutex(true, "CasunAgv");
        bool CheckApp()
        {
            bool result = false;
            if (appMutex.WaitOne(600))
                result = true;
            else
                result = false;
            return result;
        }

        /// <summary>
        /// дִ
        /// </summary>
        /// <param name="sExePath"></param>
        /// <param name="sArguments"></param>
        static void CmdStartCTIProc(string sExePath, string sArguments)
        {
            Process p = new Process();
            p.StartInfo.FileName = "cmd.exe";
            p.StartInfo.UseShellExecute = false;
            p.StartInfo.RedirectStandardInput = true;
            p.StartInfo.RedirectStandardOutput = true;
            p.StartInfo.RedirectStandardError = true;
            p.StartInfo.CreateNoWindow = false;
            p.StartInfo.WindowStyle = System.Diagnostics.ProcessWindowStyle.Hidden;
            p.Start();
            p.StandardInput.WriteLine(sExePath + " " + sArguments);
            p.StandardInput.WriteLine("exit");
            p.Close();

            System.Threading.Thread.Sleep(2000);//ȴĳδɣȴʱ
        }
        /// <summary>
        /// ϵͳ
        /// </summary>
        void ResetSystem()
        {
            //ҪʱĲ
            System.Diagnostics.ProcessStartInfo cp = new System.Diagnostics.ProcessStartInfo();
            cp.FileName = System.Windows.Forms.Application.ExecutablePath;
            cp.Arguments = "cmd params";
            cp.UseShellExecute = true;
            System.Diagnostics.Process.Start(cp);
        }
    }
}
