﻿using AGV_WPF.Model;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AGV_WPF.DLL
{
    public class PLCSqlDLL
    {

        /// <summary>
        /// </summary>
        /// <param name="SN1"></param>
        /// <param name="SN2"></param>
        /// <param name="flag">1写或2读或3删除</param>
 
        public bool PLCSql(string agvid, string SN1, string SN2,String flag) 
        {
            Boolean Flag =false;
            string strCon = ConfigurationManager.AppSettings["ConnString"];
            using (SqlConnection connection = new SqlConnection(strCon))
            {
                connection.Open();
                SqlCommand cmd = new SqlCommand("PLCproc", connection);
                cmd.Parameters.Add("@param1", SqlDbType.VarChar).Value = agvid;
                cmd.Parameters.Add("@param2", SqlDbType.VarChar).Value= SN1;
                cmd.Parameters.Add("@param3", SqlDbType.VarChar).Value = SN2;


                cmd.Parameters.Add("@flag", SqlDbType.VarChar).Value=flag;
              
                //cmd.Parameters["@param1"].Direction = ParameterDirection.Input;                          
                //cmd.Parameters["@param2"].Direction = ParameterDirection.Input;//Outpu

                cmd.Connection = connection;
                cmd.CommandType = CommandType.StoredProcedure;//这里标识调用类型

                //SqlDataReader dr = cmd.ExecuteReader(); //执行SQL语句,返回结果集合
                int rerows = cmd.ExecuteNonQuery();                       //int rerows = cmd.ExecuteNonQuery();//执行SQL语句,受影响的行数
                if (rerows>0)
                {
                    Flag= true;
                }
               // dr.Close(); //关闭执行
                connection.Close(); //关闭数据库
            }

            return Flag;
        }


        public bool PLCSqlMES(string agvid, string SN1, string SN2,string SN3,String flag)
        {
            Boolean Flag = false;
            string strCon = ConfigurationManager.AppSettings["ConnString"];
            using (SqlConnection connection = new SqlConnection(strCon))
            {
                connection.Open();
                SqlCommand cmd = new SqlCommand("PLCproc", connection);
                cmd.Parameters.Add("@param1", SqlDbType.VarChar).Value = agvid;
                cmd.Parameters.Add("@param2", SqlDbType.VarChar).Value = SN1;
                cmd.Parameters.Add("@param3", SqlDbType.VarChar).Value = SN2;
                cmd.Parameters.Add("@param4", SqlDbType.VarChar).Value = SN3;

                cmd.Parameters.Add("@flag", SqlDbType.VarChar).Value = flag;

                //cmd.Parameters["@param1"].Direction = ParameterDirection.Input;                          
                //cmd.Parameters["@param2"].Direction = ParameterDirection.Input;//Outpu

                cmd.Connection = connection;
                cmd.CommandType = CommandType.StoredProcedure;//这里标识调用类型

                //SqlDataReader dr = cmd.ExecuteReader(); //执行SQL语句,返回结果集合
                int rerows = cmd.ExecuteNonQuery();                       //int rerows = cmd.ExecuteNonQuery();//执行SQL语句,受影响的行数
                if (rerows > 0)
                {
                    Flag = true;
                }
                // dr.Close(); //关闭执行
                connection.Close(); //关闭数据库
            }

            return Flag;
        }

        public DataTable PLCSqlSelectAll()
        {
            DataTable dt = new DataTable();
            string strCon = ConfigurationManager.AppSettings["ConnString"];
            using (SqlConnection conn = new SqlConnection(strCon))
            {
              
                conn.ConnectionString = strCon;
                conn.Open(); // 打开数据库连接

                SqlDataAdapter myda = new SqlDataAdapter("exec dbo.PLCproc '','','','','0'", conn); // 实例化适配器
                              
                myda.Fill(dt); // 保存数据   

                conn.Close(); // 关闭数据库连接
            }
            return dt;

        }


        public void PLCSqlSelect(string agvid, string flag,ref string SN1, ref string SN2)
        {
            DataTable data = new DataTable();
            string strCon = ConfigurationManager.AppSettings["ConnString"];
            using (SqlConnection connection = new SqlConnection(strCon))
            {
                connection.Open();
                SqlCommand cmd = new SqlCommand("PLCproc", connection);
                cmd.Parameters.Add("@param1", SqlDbType.VarChar).Value = agvid;
                cmd.Parameters.Add("@param2", SqlDbType.VarChar).Value = "";
                cmd.Parameters.Add("@param3", SqlDbType.VarChar).Value = "";
                cmd.Parameters.Add("@param4", SqlDbType.VarChar).Value = "";
                cmd.Parameters.Add("@flag", SqlDbType.VarChar).Value = flag;  //查询

                cmd.Connection = connection;
                cmd.CommandType = CommandType.StoredProcedure;//这里标识调用类型
                SqlDataReader dr = cmd.ExecuteReader(); //执行SQL语句,返回结果集合
                                                 //int rerows = cmd.ExecuteNonQuery();//执行SQL语句,受影响的行数
                while (dr.Read())
                {
                    if (dr["SN1"].ToString() != "" ) 
                    {
                        SN1 = dr["SN1"].ToString();
                        SN2 = dr["SN2"].ToString();
                      
                    }
                    //返回结果处理
                    //dr[0],dr["col_name"]
                }
                
                dr.Close(); //关闭执行
                connection.Close(); //关闭数据库
            }


        }

        public void PLCMESSelect(string agvid, string flag, ref AGVInfo Agvinfo)
        {
            DataTable data = new DataTable();
            string strCon = ConfigurationManager.AppSettings["ConnString"];
            using (SqlConnection connection = new SqlConnection(strCon))
            {
                connection.Open();
                SqlCommand cmd = new SqlCommand("PLCproc", connection);
                cmd.Parameters.Add("@param1", SqlDbType.VarChar).Value = agvid;
                cmd.Parameters.Add("@param2", SqlDbType.VarChar).Value = "";
                cmd.Parameters.Add("@param3", SqlDbType.VarChar).Value = "";
                cmd.Parameters.Add("@param4", SqlDbType.VarChar).Value = "";
                cmd.Parameters.Add("@flag", SqlDbType.VarChar).Value = flag;  //查询

                cmd.Connection = connection;
                cmd.CommandType = CommandType.StoredProcedure;//这里标识调用类型
                SqlDataReader dr = cmd.ExecuteReader(); //执行SQL语句,返回结果集合
                Agvinfo.AgvCode = int.Parse(agvid);                  //int rerows = cmd.ExecuteNonQuery();//执行SQL语句,受影响的行数
                while (dr.Read())
                {
                    if (dr["SN1"].ToString() != "")
                    {
                        
                        Agvinfo.ProductCode = dr["SN1"].ToString();
                        Agvinfo.HolderBarCode = dr["SN2"].ToString();
                        Agvinfo.ProductType = dr["SN3"].ToString();
                    }
                    //返回结果处理
                    //dr[0],dr["col_name"]
                }

                dr.Close(); //关闭执行
                connection.Close(); //关闭数据库
            }


        }
    }

    public enum SqlType
    {
        insert = 1,
        read = 2,
        delete = 3
    }
}
