﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DataServices;
using System.Data;
using System.Data.OleDb;
using System.Windows.Forms;

namespace DataServices
{
    public class ExcelDataBase:DataBase
    {
        OleDbConnection con;
        public ExcelDataBase(string dataFile)
        {
            con = new OleDbConnection();
            DataFile = dataFile;
            if (DataFile.EndsWith(".xls"))
            {
                this.ConStr = @"provider=Microsoft.Jet.OLEDB.4.0;Persist Security Info=False;Data Source=" + DataFile + ";Extended Properties='Excel 8.0;HDR=YES'";
            }
            else if (DataFile.EndsWith(".xlsx"))
            {
                this.ConStr = @"provider=Microsoft.ACE.OLEDB.12.0;Persist Security Info=False;Data Source=" + DataFile + ";Extended Properties='Excel 8.0;HDR=YES'";
            }
            con.ConnectionString = this.ConStr;
            try
            {
                con.Open();
            }
            catch (System.Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            
        }

        public override void Close()
        {
            if (con != null)
            {
                con.Close();
                con.Dispose();

            }
        }
        public override void Dispose()
        {
            if (con != null)
                con.Dispose();
            base.Dispose();
        }
        public string CreateTable(string fileName, string tableName = "路线")
        {
            string conStr = "";
            try
            {
                if (fileName.EndsWith(".xls"))
                {
                    conStr = @"provider=Microsoft.Jet.OLEDB.4.0;Persist Security Info=False;Data Source=" + fileName + ";Extended Properties='Excel 8.0;HDR=YES'";
                }
                else if (fileName.EndsWith(".xlsx"))
                {
                    conStr = @"provider=Microsoft.ACE.OLEDB.12.0;Persist Security Info=False;Data Source=" + fileName + ";Extended Properties='Excel 8.0;HDR=YES'";
                }
                //using (OleDbConnection con = new OleDbConnection(conStr))
                {
                    if (con.State != ConnectionState.Open)
                        con.Open();
/*
                    if (IsExistTable(fileName, tableName))//如果存在表则返回
                        return conStr;*/
                    using (OleDbCommand com = new OleDbCommand())
                    {
                        com.Connection = con;
                        com.CommandText = @"CREATE TABLE [" + tableName + "]" + "([序号] INT,[生产区号] INT,[AGV编号] INT,[路线编号] INT,[站点序号] INT,[站点编号] INT)";


                        com.ExecuteNonQuery();
                        return conStr;
                    }
                }

            }

            catch (System.Exception ex)
            {
                throw new Exception(ex.Message);
            }
            //return conStr;
        }

        public string CreateTable(string fileName, string tableName,string columnsParameter)
        {
            string conStr = "";
            if (string.IsNullOrEmpty(fileName) || string.IsNullOrEmpty(tableName) || string.IsNullOrEmpty(columnsParameter))
            {
                throw new Exception("参数不能为空");
            }
            try
            {
                if (fileName.EndsWith(".xls"))
                {
                    conStr = @"provider=Microsoft.Jet.OLEDB.4.0;Persist Security Info=False;Data Source=" + fileName + ";Extended Properties='Excel 8.0;HDR=YES'";
                }
                else if (fileName.EndsWith(".xlsx"))
                {
                    conStr = @"provider=Microsoft.ACE.OLEDB.12.0;Persist Security Info=False;Data Source=" + fileName + ";Extended Properties='Excel 8.0;HDR=YES'";
                }
                //using (OleDbConnection con = new OleDbConnection(conStr))
                {
                    if (con.State != ConnectionState.Open)
                        con.Open();
/*
                    if (IsExistTable(fileName, tableName))//如果存在表则返回
                        return conStr;*/
                    using (OleDbCommand com = new OleDbCommand())
                    {
                        com.Connection = con;
                        com.CommandText = @"CREATE TABLE [" + tableName + "]" + "(" + columnsParameter + ")";


                        com.ExecuteNonQuery();
                        return conStr;
                    }
                }

            }

            catch (System.Exception ex)
            {
                throw new Exception(ex.Message);
            }
            finally
            {
                if (!IsAlwaysOpen)
                    con.Close();
            }
            //return conStr;
        }
        public bool IsExistTable(string fileName, string tableName = "路线")
        {
            string conStr = "";
            if (fileName.EndsWith(".xls"))
            {
                conStr = @"provider=Microsoft.Jet.OLEDB.4.0;Persist Security Info=False;Data Source=" + fileName + ";Extended Properties='Excel 8.0;HDR=YES'";
            }
            else if (fileName.EndsWith(".xlsx"))
            {
                conStr = @"provider=Microsoft.ACE.OLEDB.12.0;Persist Security Info=False;Data Source=" + fileName + ";Extended Properties='Excel 8.0;HDR=YES'";
            }
            try
            {
                //using (OleDbConnection con = new OleDbConnection(conStr))
                {
                    if (con.State != ConnectionState.Open)
                        con.Open();
                    DataTable schemaTable = con.GetOleDbSchemaTable(OleDbSchemaGuid.Tables, new object[] { null, null, null, "Table" });
                    foreach (DataRow row in schemaTable.Rows)
                    {
                        if (row["Table_Name"].Equals(tableName) || row["Table_Name"].Equals(tableName + "$"))
                        {
                            return true;
                        }
                        
                    }

                }
            }
            catch (System.Exception ex)
            {
                throw new Exception(ex.Message);
            }
            finally
            {
                if (!IsAlwaysOpen)
                    con.Close();
            }
            return false;
        }
        public List<string> GetAllTables(string fileName)
        {
            List<string> tableList = new List<string>();
            string conStr = "";
            if (fileName.EndsWith(".xls"))
            {
                conStr = @"provider=Microsoft.Jet.OLEDB.4.0;Persist Security Info=False;Data Source=" + fileName + ";Extended Properties='Excel 8.0;HDR=YES'";
            }
            else if (fileName.EndsWith(".xlsx"))
            {
                conStr = @"provider=Microsoft.ACE.OLEDB.12.0;Persist Security Info=False;Data Source=" + fileName + ";Extended Properties='Excel 8.0;HDR=YES'";
            }
            try
            {
                using (OleDbConnection con = new OleDbConnection(conStr))
                {
                    con.Open();
                    DataTable schemaTable = con.GetOleDbSchemaTable(OleDbSchemaGuid.Tables, new object[] { null, null, null, "Table" });
                    foreach (DataRow row in schemaTable.Rows)
                    {
                        tableList.Add(row["Table_Name"].ToString());
                    }
/*
                    foreach (string str in tableList)
                    {
                        using (OleDbCommand com = new OleDbCommand(string.Format("select * from [{0}]", str), con))
                        {
                            OleDbDataReader reader = com.ExecuteReader();
                            while (reader.Read())
                            {
                                for (int i = 0; i < reader.FieldCount;i++ )
                                {
                                    Console.Write(string.Format("{0},", reader.GetValue(i).ToString()));
                                }
                                Console.WriteLine();
                            }
                        }
                    }*/
                }
            }
            catch (System.Exception ex)
            {
                throw new Exception(ex.Message);
            }
            return tableList;
        }
        public OleDbConnection GetConnection(string fileName)
        {
            string conStr = "";
            OleDbConnection con = null;
            if (fileName.EndsWith(".xls"))
            {
                conStr = @"provider=Microsoft.Jet.OLEDB.4.0;Persist Security Info=False;Data Source=" + fileName + ";Extended Properties='Excel 8.0;HDR=YES'";
            }
            else if (fileName.EndsWith(".xlsx"))
            {
                conStr = @"provider=Microsoft.ACE.OLEDB.12.0;Persist Security Info=False;Data Source=" + fileName + ";Extended Properties='Excel 8.0;HDR=YES'";
            }
            try
            {
                con = new OleDbConnection(conStr);
                if (con.State != ConnectionState.Open)
                    con.Open();
            }
            catch (System.Exception ex)
            {
                throw new Exception(ex.Message);
            }
            return con;
        }
        public int GetTableCount(OleDbConnection con, string tableName)
        {

            try
            {
                if (con.State != ConnectionState.Open)
                    con.Open();
                using (OleDbCommand com = new OleDbCommand())
                {
                    com.Connection = con;

                    com.CommandText = @"select count(*) from [" + tableName + "]";
                    OleDbDataReader read = com.ExecuteReader();
                    while (read.Read())
                    {
                        return read.GetInt32(0);
                    }
                    read.Close();
                }
            }
            catch (System.Exception ex)
            {
                throw new Exception(ex.Message);
            }
            finally
            {
                if (!IsAlwaysOpen)
                    con.Close();
            }
            return 0;
        }

        public override void Open()
        {
            if (!string.IsNullOrEmpty(ConStr))
            {
                try
                {
                    if (con == null)
                        con = new OleDbConnection(ConStr);
                    if (con.State == ConnectionState.Open)
                        con.Close();
                    
                    con.ConnectionString = this.ConStr;
                    con.Open();
                    
                }
                catch (System.Exception ex)
                {
                    throw new Exception(ex.Message);
                }
            }
        }

        public override void Open(string dataSource, string dataFile, string userName = null, string passWord = "")
        {
            throw new NotImplementedException();
        }

        public override void Open(string fileName)
        {
            string conStr = "";
            if (fileName.EndsWith(".xls"))
            {
                conStr = @"provider=Microsoft.Jet.OLEDB.4.0;Persist Security Info=False;Data Source=" + fileName + ";Extended Properties='Excel 8.0;HDR=YES'";
            }
            else if (fileName.EndsWith(".xlsx"))
            {
                conStr = @"provider=Microsoft.ACE.OLEDB.12.0;Persist Security Info=False;Data Source=" + fileName + ";Extended Properties='Excel 8.0;HDR=YES'";
            }
            try
            {
                if (con == null)
                    con = new OleDbConnection(conStr);
                if (con.State == ConnectionState.Open)
                    con.Close();
                
                ConStr = conStr;
                con.ConnectionString = conStr;
                con.Open();
                
            }

            catch (System.Exception ex)
            {
                throw new Exception(ex.Message);
            }
        }

        public override void ExecuteNonQuery(string sqlCommand)
        {
           try
           {
               if (con.State != ConnectionState.Open)
               {
                   Open(DataFile);
               }
               using (OleDbCommand com = new OleDbCommand(sqlCommand,con))
               {
                   com.ExecuteNonQuery();
               }
               
           }
           catch (System.Exception ex)
           {
               throw new Exception(ex.Message);
           }
           finally
           {
               if (!IsAlwaysOpen)
                   con.Close();
           }
        }

        public override object Execute(string sqlCommand)
        {
            DataTable table = new DataTable();
            try
            {
                if (con.State != ConnectionState.Open)
                {
                    Open(DataFile);
                }
                using (OleDbCommand com = new OleDbCommand(sqlCommand, con))
                {
                    using (OleDbDataAdapter da = new OleDbDataAdapter(com))
                    {
                        da.Fill(table);
                        return table;
                    }
                }

            }
            catch (System.Exception ex)
            {
                throw new Exception(ex.Message);
            }
            finally
            {
                if (!IsAlwaysOpen)
                    con.Close();
            }
            //return table;
        }

        public override void ExecuteNonQuery(string sqlCommand, string conStr)
        {
            throw new NotImplementedException();
        }

        public override object Execute(string sqlCommand, string conStr)
        {
            throw new NotImplementedException();
        }
    }
}
