﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DataServices;
using System.Data;

namespace DataServices
{
    public class MissRecord
    {
        static object lockObject = new object();
        public static void Insert(ref DataBase data, int workLine, int agvNum, int route, int lastStation,int shouldStation,int actualStation,string information, string time,string tableName="漏读记录")
        {
            lock(lockObject)//每次只能插入一条记录
            {
                ExcelDataBase exceldata = (ExcelDataBase)data;
                if (!exceldata.IsExistTable(exceldata.DataFile, tableName))
                {
                    exceldata.CreateTable(exceldata.DataFile, tableName, @"[序号] int,[生产区] int,[AGV编号] int,[路线编号] int,[上次站点] int,[应读站点] int,[实读站点] int,[记录信息] varchar,[产生时间] varchar");
                }
                int count = exceldata.GetTableCount(exceldata.GetConnection(exceldata.DataFile), tableName + "$");
                //string sql = @"insert into " + "[" + tableName + "$" + "]([序号],[生产区],[AGV编号],[路线编号],[漏读站点号],[漏读时间]) values(" + (count + 1).ToString() + "," + workLine.ToString() + "," + agvNum.ToString() + "," + route.ToString() + "," + lastStation.ToString() + "," + shouldStation.ToString() + "'" + time + "')";
                string sql = string.Format(@"insert into [{0}$]([序号],[生产区],[AGV编号],[路线编号],[上次站点],[应读站点],[实读站点],[记录信息],[产生时间]) values({1},{2},{3},{4},{5},{6},{7},'{8}','{9}')", tableName, count + 1, workLine, agvNum, route, lastStation, shouldStation, actualStation, information, time);
                exceldata.ExecuteNonQuery(sql);
            }
        }


        public static DataTable Select(ref DataBase data,string sqlCommand, string tableName = "漏读记录")
        {
            ExcelDataBase exceldata = (ExcelDataBase)data;
            if (!exceldata.IsExistTable(exceldata.DataFile, tableName))
            {
                exceldata.CreateTable(exceldata.DataFile, tableName, @"[序号] int,[生产区] int,[AGV编号] int,[路线编号] int,[上次站点] int,[应读站点] int,[实读站点] int,[记录信息] varchar,[产生时间] varchar");
            }

            DataTable table = null;
            try
            {
                table = (DataTable)data.Execute(sqlCommand);
            }
            catch (System.Exception ex)
            {
                throw new Exception(ex.Message);
            }
            return table;

        }
    }
}
