﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.IO;
using AGV_WPF_Global;

namespace AGV_WPF.NewCotent
{
    /// <summary>
    /// 群创用异常日志文件（AGV异常，非程序异常）
    /// </summary>
    public class ErrorLog
    {
        public static Mutex m_Mutex = new Mutex();
        public static string m_Directory = "Log";//存放目录
        public static string m_ErrorFile = "ErrorLog.txt";//异常文件
        static bool m_StaticFileFlag = false;//是否用静态文件
        public static void WriteErrorLog(string areaName,int agvNum, int errorCode, DateTime happenedTime, DateTime recoveryTime)
        {
            m_Mutex.WaitOne();
            string filePath = GetFilePath();
            if (errorCode > 0 && errorCode < 0x40)
            {
                errorCode += 1;
                StreamWriter writer = new StreamWriter(filePath,true);
                //Date,Time,BayNo,AGVNo,ErrorCode,RecoveryTime
                //20151220,210234,B,14,1,210531
                string msg = string.Format("{0},{1},{2},{3},{4},{5}",happenedTime.ToString("yyyyMMdd"),happenedTime.ToString("HHmmss"),areaName,agvNum,errorCode,recoveryTime.ToString("HHmmss"));
                writer.WriteLine(msg);

                writer.Close();
            }
            m_Mutex.ReleaseMutex();
        }

        public static void WriteErrorLogagv(string a)
        {
            m_Mutex.WaitOne();
            string filePath = GetFilePath();
            //if (errorCode > 0 && errorCode < 0x40)
            {
               // errorCode += 1;
                StreamWriter writer = new StreamWriter(filePath, true);
                //Date,Time,BayNo,AGVNo,ErrorCode,RecoveryTime
                //20151220,210234,B,14,1,210531
                //string msg = string.Format("{0},{1},{2},{3},{4},{5}", happenedTime.ToString("yyyyMMdd"), happenedTime.ToString("HHmmss"), areaName, agvNum, errorCode, recoveryTime.ToString("HHmmss"));
                writer.WriteLine(a);

                writer.Close();
            }
            m_Mutex.ReleaseMutex();
        }
       
        static string GetFilePath()
        {
            //文件夹是否存在
            if(!System.IO.Directory.Exists(m_Directory))
            {
                System.IO.Directory.CreateDirectory(m_Directory);
            }

            if (m_StaticFileFlag)
            {
                return string.Format(@"{0}\{1}", m_Directory, m_ErrorFile);
            }
            else
            {
                return string.Format(@"{0}\ErroLog-{1}.txt", m_Directory, DateTime.Now.ToString("yyyyMMdd"));//按日期存放
            }
        }
    }
}
