﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AGV_WPF.TrafficDefine
{
    public class TrafficArea
    {
        public TrafficArea()
        {
            WaitAgvList = new List<int>();
            StationList = new List<TrafficStation>();
            //KeyStation = new TrafficStation();
        }
        /// <summary>
        /// 管制区编号
        /// </summary>
        public int TrafficNum;
        /// <summary>
        /// 管制区状态，true有AGV在管制区，false无AGV在管制区
        /// </summary>
        public bool Status;
        /// <summary>
        /// 占有该管制区的AGV编号
        /// </summary>
        public int OccupyAgv;
        /// <summary>
        /// 等待的AGV
        /// </summary>
        public List<int> WaitAgvList;
        /// <summary>
        /// 管制区站点
        /// </summary>
        public List<TrafficStation> StationList;//里面包含关键点
        public bool IsNeedKeyMark;
        
    }

    public struct MarkStation
    {
        public int WorkLine;//生产区
        public int MarkNum;//地标号
    }
    /// <summary>
    /// 管制区点定义
    /// </summary>
    public class TrafficStation
    {
        /*public bool IsKeyMark;//是否关键点
        public int WorkLine;//生产区
        public int MarkNum;//地标号*/
        public MarkStation CurrentMark;//当前点
        public MarkStation NextMark;//下一点
    }
    public class AgvStatus         //AGV状态,可显示到屏
    {
        public AgvStatus()
        {
            TrafficNumList = new List<int>();
        }
        public bool WirelessStaus;         //无线连接状态
        public int WirelessLinkCount;    //无线连接中断次数
        public int AgvNum;			//AGV标号
        public int WorkLine;		//生产区
        public int MarkNum;			//当前地标
        public int MarkFunction;	//地标功能
        public List<int> TrafficNumList;    	//管制区号
        public int Status;			//运行状态
        public int Route;			//当前线路
        public int Speed;          //当前速度
        public float Voltage;      //电压
        public float Current;      //电流
        public byte LoadingStatus;//货物状态，0不上不下，1牵引棒上升，2牵引棒下降
        public float Temperature;  //电池温度
    };
}
