using AGV_WPF_Global;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace AGV_WPF
{
    public partial class WirelessDockingSystem : Form
    {
        public WirelessDockingSystem()
        {
            InitializeComponent();
            for(int i = 1; i <= 8; i++)
            {
                DataGridViewCheckBoxColumn col = new DataGridViewCheckBoxColumn();
                col.HeaderText = "Y"+i;
                col.Name = "Y" + i;
                col.ReadOnly = true;
                col.Resizable = DataGridViewTriState.True;
                col.SortMode = DataGridViewColumnSortMode.Automatic;
                dataGridView1.Columns.Insert(dataGridView1.Columns.Count-2,col);
            }
            for (int i = 1; i <= 8; i++)
            {
                DataGridViewCheckBoxColumn col = new DataGridViewCheckBoxColumn();
                col.HeaderText = "X" + i;
                col.Name = "X" + i;
                col.ReadOnly = true;
                col.Resizable = DataGridViewTriState.True;
                col.SortMode = DataGridViewColumnSortMode.Automatic;
                dataGridView1.Columns.Insert(dataGridView1.Columns.Count - 2, col);
            }
        }

        private void WirelessDockingSystem_Load(object sender, EventArgs e)
        {
            for(int i=0; i< GlobalPara.DtWirelessBox.Rows.Count; i++)
            {
                int row = dataGridView1.Rows.Add();
                dataGridView1.Rows[row].Cells[0].Value = i + 1;
                dataGridView1.Rows[row].Cells[1].Value = GlobalPara.DtWirelessBox.Rows[i]["豸"].ToString();
                dataGridView1.Rows[row].Cells["ַ"].Value = GlobalPara.DtWirelessBox.Rows[i]["豸IP"].ToString();
            }
            Task.Factory.StartNew(ThreadProc); //Task.Factory.StartNew(ThreadProc2);
        }
        private delegate void InvokeDelegate();
        public void ThreadProc()
        {
            while (true)
            {
                try
                {
                    dataGridView1.Invoke(new InvokeDelegate(delegate
                    {
                        for (int a = 0; a < dataGridView1.Rows.Count; a++)
                        {
                            var obj = GlobalPara.ListBoxData.Find(o => o["IPAddress"].ToString() == dataGridView1.Rows[a].Cells["ַ"].Value.ToString());
                            if (obj != null)
                            {
                                for(int i = 1; i < 9; i++)
                                {
                                    dataGridView1.Rows[a].Cells["X" + i].Value =  obj["In"].ToString()[8-i] == '1' ? true : false;
                                    dataGridView1.Rows[a].Cells["Y" + i].Value = obj["Out"].ToString()[8-i] == '1' ? true : false;
                                }

                                dataGridView1.Rows[a].Cells["ʱ"].Value = obj["Time"].ToString();
                            }
                        }
                    }));
                }
                catch (Exception)
                {

                }
                Thread.Sleep(1000);
            }
        }

        public void AddText(string text,int flag=1)
        {
            RichTextBox richTextBox=richTextBox1;
            if (flag == 2)
            {
                richTextBox = richTextBox2;
            }
            text = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss.fff") + ":" + text ;
            richTextBox.BeginInvoke((Action)(() =>
            {
                if (richTextBox.Lines.Length > 1000)
                {
                    richTextBox.Clear();
                }
                {
                    richTextBox.AppendText(text);
                    richTextBox.AppendText(Environment.NewLine);
                }
                int textLength = richTextBox.TextLength;
                richTextBox.Select(textLength, 4);
                richTextBox.ScrollToCaret();

            }));
        }
        public void ThreadProc2()
        {
            while (true)
            {
                try
                {
                    string path = "D:/Logs/ԽӺм¼/Logs_" + DateTime.Now.ToString("yyyyMMdd") + ".txt";
                    if (File.Exists(path))
                    {
                        string[] readText = File.ReadAllLines(path);
                        int len = readText.Length > 100 ? 100 : readText.Length;
                        richTextBox1.BeginInvoke((Action)(() =>
                        {
                            richTextBox1.Clear();
                            for (int i = 0;i<len;i++)
                            {
                                richTextBox1.AppendText(readText[i]);
                                richTextBox1.AppendText(Environment.NewLine);
                            }
                            int textLength = richTextBox1.TextLength;
                            richTextBox1.Select(textLength, 4);
                            richTextBox1.ScrollToCaret();

                        }));
                    }
                }
                catch (Exception)
                {

                }
                Thread.Sleep(1000);
            }
        }
    }
}
